"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrudGenericWForm = exports.CrudGeneric = exports.AddRoute = void 0;
const react_1 = __importDefault(require("react"));
const react_router_dom_1 = require("react-router-dom");
const add_1 = __importDefault(require("../add"));
const AddRoute = (Form, urlPrefix, addLink, crudInsert) => {
    if (!crudInsert) {
        return react_1.default.createElement(react_1.default.Fragment, null);
    }
    const Add = add_1.default(crudInsert, Form, urlPrefix);
    return react_1.default.createElement(react_router_dom_1.Route, { exact: true, path: addLink, component: Add });
};
exports.AddRoute = AddRoute;
const CrudGeneric = (ListGeneric, DetailGeneric, FormWDef) => (def, defDetail, viewFields, urlPrefix, crud, editTitle = "Edit", extras, showEditToggle = true, detailColWidth = 6) => {
    const Form = FormWDef(defDetail);
    return exports.CrudGenericWForm(ListGeneric, DetailGeneric, Form)(def, viewFields, urlPrefix, crud, editTitle, extras, showEditToggle, detailColWidth);
};
exports.CrudGeneric = CrudGeneric;
const CrudGenericWForm = (ListGeneric, DetailGeneric, Form) => (def, viewFields, urlPrefix, crud, editTitle = "Edit", extras, showEditToggle = true, detailColWidth = 6) => {
    const addLink = urlPrefix + "/add";
    const editLink = (childId) => urlPrefix + "/" + childId + "/edit";
    const redirectUrl = urlPrefix;
    const backUrl = urlPrefix;
    const List = () => (react_1.default.createElement(ListGeneric, { editLink: editLink, addLink: addLink, getData: crud.list, def: def }));
    const PreDetail = DetailGeneric(Form, viewFields, { update: crud.update, deleteById: crud.deleteById, detail: crud.detail }, redirectUrl, showEditToggle);
    const Detail = () => (react_1.default.createElement(PreDetail, { backUrl: backUrl, title: editTitle, extras: extras, detailColWidth: detailColWidth }));
    return () => (react_1.default.createElement(react_router_dom_1.Switch, null,
        exports.AddRoute(Form, urlPrefix, addLink, crud.insert),
        react_1.default.createElement(react_router_dom_1.Route, { path: editLink(":id"), component: Detail }),
        react_1.default.createElement(react_router_dom_1.Route, { path: urlPrefix, component: List })));
};
exports.CrudGenericWForm = CrudGenericWForm;
exports.default = exports.CrudGeneric;
